/**************************************************************************
 * This file is generated by Java2C
 **copyright***************************************************************
 *************************************************************************/
#include "PosCtrl/SetValueGenerator.h"
#include <string.h>  //because using memset()
#include <Jc/ReflectionJc.h>   //Reflection concept 
#include <Fwc/fw_Exception.h>  //basic stacktrace concept
#include "Fwc/fw_LogMessage.h"  //reference-association: msg
#include "Jc/StringJc.h"  //embedded ctor
#include "PosCtrl/MainController.h"  //reference-association: MainController_s
#include "PosCtrl/OamVariables.h"  //reference-association: oamVariables
#include "PosCtrl/ProcessMessageIdents.h"  //reference-association: ProcessMessageIdents_s


/* J2C: Method-table-references *********************************************************/
#ifndef LogMessageFWMTBDEF
  #define LogMessageFWMTBDEF
  typedef struct LogMessageFWMTB_t { struct Mtbl_LogMessageFW_t const* mtbl; struct LogMessageFW_t* ref; } LogMessageFWMTB;
#endif


/**This class represents a set value generator for a movement.
The idea is, a new target point may be given calling {@link setTarget(short)}
and the set value for a way controller is generate in a linear movement from actual position
to the new target point. If the target is reached, a possible next target point is taken
or the movement stands idle on the target.

It is possible and reasonable for a good control to smooth the motion.
It would be also reasonable to set a velocity and a time for stand idle on target.

In the second stage of Java2C-example only one target is stored. But a new construction is used
to test the garbage collection.

The third stage will be implemented with a LinkedList to store a higher number of targets,
but new should be also used to create a new target instance.

@author JcHartmut

*/


const char sign_Mtbl_SetValueGenerator[] = "SetValueGenerator"; //to mark method tables of all implementations

typedef struct MtblDef_SetValueGenerator_t { Mtbl_SetValueGenerator mtbl; MtblHeadJc end; } MtblDef_SetValueGenerator;
 extern MtblDef_SetValueGenerator const mtblSetValueGenerator;

/*Constructor */
struct SetValueGenerator_t* ctorO_SetValueGenerator(ObjectJc* othis, struct LogMessageFW_t* msg, struct OamVariables_t* oamVariables, ThCxt* _thCxt)
{ SetValueGenerator_s* ythis = (SetValueGenerator_s*)othis;  //upcasting to the real class.
  STACKTRC_TENTRY("ctorO_SetValueGenerator");
  checkConsistence_ObjectJc(othis, sizeof(SetValueGenerator_s), null, _thCxt);  
  setReflection_ObjectJc(othis, &reflection_SetValueGenerator_s, sizeof(SetValueGenerator_s));  
  //j2c: Initialize all class variables:
  {
    ythis->value = 10000;
    ythis->dvalue = 10;
    ythis->isWaitingForTarget = false;
    ythis->state = ((/*J2C:cast% from int32*/int16)(kWaitForNewTarget_State_SetValueGenerator));
    //J2C: constructor for embedded fix-size-StringBuffer
      init_ObjectJc(&ythis->bufferFormatter.sb.base.object, sizeof(StringBuilderJc) + 400 - 4, 0);
      ctorO_I_StringBuilderJc(&ythis->bufferFormatter.sb.base.object, 400, _thCxt);
    //J2C: constructor for embedded element-ObjectJc
      init_ObjectJc(&(ythis->sFormatter.base.object), sizeof(ythis->sFormatter), 0); 
      ctorO_Sb_StringFormatterJc(/*static*/&(ythis->sFormatter.base.object), & (ythis->bufferFormatter.sb), _thCxt);
  }
  { 
    
    SETREFJc(ythis->msg, msg, LogMessageFW_i);
    SETREFJc(ythis->oamVariables, oamVariables, OamVariables_s);//sFormatter.
    
  }
  STACKTRC_LEAVE;
  return ythis;
}



/**generates the next reference value.*/
int16 step_SetValueGenerator_F(ObjectJc* ithis, ThCxt* _thCxt)
{ SetValueGenerator_s* ythis = (SetValueGenerator_s*)ithis;
  
  STACKTRC_TENTRY("step_SetValueGenerator_F");
  
  { 
    int16 newState = 0; 
    LogMessageFWMTB msg;   /**/
    
    
    /*no initvalue*/
    SETMTBJc(msg, REFJc(ythis->msg), LogMessageFW);
    do 
      { 
        
        newState = -1;
        switch(ythis->state){
          case kToTarget_State_SetValueGenerator: 
          { //:assert actTarget != null;
            
            int32 dToTarget; 
            
            
            dToTarget = REFJc(ythis->actTarget)->target - ythis->value;
            if(ythis->dvalue > 0 ? dToTarget < ythis->dvalue : dToTarget > ythis->dvalue) 
            { 
              struct Target_SetValueGenerator_t* testTarget = null; 
              
              
              /*The last step: add only the diff to the target. */
              ythis->dvalue = (int16)dToTarget;
              newState = ((/*J2C:cast% from int32*/int16)(kStandStill_State_SetValueGenerator));
              ythis->countStandStill = 10;//it is the onentry-action in standStill-state
              
              msg.mtbl->sendMsg( (msg.ref), endPositionReached_ProcessMessageIdents, "end position reached", "SBBB", ythis->value, 0, 0, 0);//Example for String processing:
              
              /*no initvalue*/
              testTarget = REFJc(ythis->actTarget);
            }
            ythis->value += ythis->dvalue;
          }break;
          case kStandStill_State_SetValueGenerator: 
          { 
            
            if(--ythis->countStandStill == 0) 
            { 
              
              newState = ((/*J2C:cast% from int32*/int16)(kWaitForNewTarget_State_SetValueGenerator));
            }
          }break;
          case kWaitForNewTarget_State_SetValueGenerator: 
          { 
            
            if(REFJc(ythis->nextTarget) != null) 
            { 
              
              /**The current nextTarget is used as actTarget, the nextTarget is null then. */
              SETREFJc(ythis->actTarget, REFJc(ythis->nextTarget), Target_SetValueGenerator_s);
              CLEARREFJc(ythis->nextTarget);
              ythis->dvalue = (int16)(REFJc(ythis->actTarget)->target > ythis->value ? 10 : -10);
              if(ythis->value > REFJc(ythis->actTarget)->target) 
              { }
              if(ythis->isWaitingForTarget) 
              { 
                
                msg.mtbl->sendMsg( (msg.ref), -waitForTargetPosition_ProcessMessageIdents, "wait for target %d", "SBBB", ythis->value, 0, 0, 0);
                ythis->isWaitingForTarget = false;
              }
              msg.mtbl->sendMsg( (msg.ref), newTargetPosition_ProcessMessageIdents, "new target %d = %3.2e", "SF", REFJc(ythis->actTarget)->target, REFJc(ythis->actTarget)->target * 1.0F);//TODO: it doesnot work yet in Java2C msg.sendMsg(ProcessMessageIdents.kNewTarget, "new target", actTarget.target);
              
              newState = ((/*J2C:cast% from int32*/int16)(kToTarget_State_SetValueGenerator));
            }
            else 
            { 
              
              ythis->countStandStill -= 1;//count for debug.
              
              if(!ythis->isWaitingForTarget) 
              { 
                
                msg.mtbl->sendMsg( (msg.ref), waitForTargetPosition_ProcessMessageIdents, "wait for target %d", "SBBB", ythis->value, 0, 0, 0);
                ythis->isWaitingForTarget = true;
              }
            }
          }break;
        }/*switch*/;
        if(newState > 0) 
        { //:a state switch:
          
          
          ythis->state = newState;
        }
      }while(newState >= 0);//continue on stateSwitch, run with new state
    
    REFJc(ythis->oamVariables)->stateSetValueGen = ythis->state;
    REFJc(ythis->oamVariables)->targetWay = REFJc(ythis->actTarget) == null ? 0 : REFJc(ythis->actTarget)->target;
    REFJc(ythis->oamVariables)->wway = ythis->value;
    { STACKTRC_LEAVE;
      return ythis->value;
    }
  }
  STACKTRC_LEAVE;
}

/*J2C: dynamic call variant of the override-able method: */
int16 step_SetValueGenerator(ObjectJc* ithis, ThCxt* _thCxt)
{ Mtbl_SetValueGenerator_ifc const* mtbl = (Mtbl_SetValueGenerator_ifc const*)getMtbl_ObjectJc(ithis, sign_Mtbl_SetValueGenerator_ifc);
  return mtbl->step(ithis, _thCxt);
}


/**stores a next target point*/
bool setTarget_i_SetValueGenerator_F(ObjectJc* ithis, int16 targetValue, ThCxt* _thCxt)
{ SetValueGenerator_s* ythis = (SetValueGenerator_s*)ithis;
  
  STACKTRC_TENTRY("setTarget_i_SetValueGenerator_F");
  
  { 
    
    if(REFJc(ythis->nextTarget) != null) { STACKTRC_LEAVE;
      return false;
    }
    else 
    { 
      struct Target_SetValueGenerator_t* newTarget = null;   /*In C mentality a switching buffer of fix instances or such will be used.*/
      
      ObjectJc *newObj2_1=null; //J2C: temporary Objects for new operations
      
      
      newTarget = ctorO_Target_SetValueGenerator(/*static*/(newObj2_1 = alloc_ObjectJc(sizeof_Target_SetValueGenerator_s, 0, _thCxt)), _thCxt);
      newTarget->target = targetValue;
      SETREFJc(ythis->nextTarget, newTarget, Target_SetValueGenerator_s);
      ((Mtbl_LogMessageFW const*)getMtbl_ObjectJc(&(REFJc(ythis->msg))->base.object, sign_Mtbl_LogMessageFW) )->sendMsg(REFJc(ythis->msg), setNewTargetPosition_ProcessMessageIdents, "new Target position: %d", "S", targetValue);
      { STACKTRC_LEAVE;
        activateGarbageCollectorAccess_BlockHeapJc(newObj2_1, null);
        return true;
      }
    }
  }
  STACKTRC_LEAVE;
}

/*J2C: dynamic call variant of the override-able method: */
bool setTarget_i_SetValueGenerator(ObjectJc* ithis, int16 targetValue, ThCxt* _thCxt)
{ Mtbl_SetValueGenerator_ifc const* mtbl = (Mtbl_SetValueGenerator_ifc const*)getMtbl_ObjectJc(ithis, sign_Mtbl_SetValueGenerator_ifc);
  return mtbl->setTarget(ithis, targetValue, _thCxt);
}


/**returns true if the next target is required.*/
bool requiresNextTarget_SetValueGenerator_F(SetValueGenerator_s* ythis, ThCxt* _thCxt)
{ 
  STACKTRC_TENTRY("requiresNextTarget_SetValueGenerator_F");
  
  { 
    
    { STACKTRC_LEAVE;
      return REFJc(ythis->nextTarget) == null;
    }
  }
  STACKTRC_LEAVE;
}

/*J2C: dynamic call variant of the override-able method: */
bool requiresNextTarget_SetValueGenerator(SetValueGenerator_s* ythis, ThCxt* _thCxt)
{ Mtbl_SetValueGenerator const* mtbl = (Mtbl_SetValueGenerator const*)getMtbl_ObjectJc(&ythis->base.object, sign_Mtbl_SetValueGenerator);
  return mtbl->requiresNextTarget(ythis, _thCxt);
}


void finalize_SetValueGenerator_F(ObjectJc* othis, ThCxt* _thCxt)
{ SetValueGenerator_s* ythis = (SetValueGenerator_s*)othis;  //upcasting to the real class.
 STACKTRC_TENTRY("finalize_SetValueGenerator_F");
  CLEAR_REFJc(ythis->msg);
  CLEAR_REFJc(ythis->oamVariables);
  finalize_ObjectJc_F(&ythis->bufferFormatter.sb.base.object, _thCxt); //J2C: finalizing the embedded instance.
  finalize_ObjectJc_F(&ythis->sFormatter.base.object, _thCxt); //J2C: finalizing the embedded instance.
  CLEAR_REFJc(ythis->actTarget);
  CLEAR_REFJc(ythis->nextTarget);
  finalize_ObjectJc_F(&ythis->base.object, _thCxt); //J2C: finalizing the superclass.
  STACKTRC_LEAVE;
}




/**J2C: Reflections and Method-table *************************************************/
const MtblDef_SetValueGenerator mtblSetValueGenerator = {
{ { sign_Mtbl_SetValueGenerator//J2C: Head of methodtable.
  , (struct Size_Mtbl_t*)((1 +2) * sizeof(void*)) //size. NOTE: all elements are standard-pointer-types.
  }
, requiresNextTarget_SetValueGenerator_F //requiresNextTarget
, { { sign_Mtbl_ObjectJc//J2C: Head of methodtable.
    , (struct Size_Mtbl_t*)((5 +2) * sizeof(void*)) //size. NOTE: all elements are standard-pointer-types.
    }
  , clone_ObjectJc_F //clone
  , equals_ObjectJc_F //equals
  , finalize_SetValueGenerator_F //finalize
  , hashCode_ObjectJc_F //hashCode
  , toString_ObjectJc_F //toString
  }
  /**J2C: Mtbl-interfaces of SetValueGenerator: */
, { { sign_Mtbl_SetValueGenerator_ifc//J2C: Head of methodtable.
    , (struct Size_Mtbl_t*)((2 +2) * sizeof(void*)) //size. NOTE: all elements are standard-pointer-types.
    }
  , setTarget_i_SetValueGenerator_F //setTarget
  , step_SetValueGenerator_F //step
  , { { sign_Mtbl_ObjectJc//J2C: Head of methodtable.
      , (struct Size_Mtbl_t*)((5 +2) * sizeof(void*)) //size. NOTE: all elements are standard-pointer-types.
      }
    , clone_ObjectJc_F //clone
    , equals_ObjectJc_F //equals
    , finalize_SetValueGenerator_F //finalize
    , hashCode_ObjectJc_F //hashCode
    , toString_ObjectJc_F //toString
    }
  }
}, { signEnd_Mtbl_ObjectJc, null } }; //Mtbl


 extern struct ClassJc_t const reflection_ObjectJc;
 static struct superClasses_SetValueGenerator_s_t
 { ObjectArrayJc head;
   ClassOffset_idxMtblJc data[1];
 }superclasses_SetValueGenerator_s =
 { CONST_ObjectArrayJc(ClassOffset_idxMtblJc, 1, OBJTYPE_ClassOffset_idxMtblJc, null, null)
 , { {&reflection_ObjectJc, OFFSET_Mtbl(Mtbl_SetValueGenerator, ObjectJc) }
   }
 };

 extern struct ClassJc_t const reflection_SetValueGenerator_ifc_s;
 static struct ifcClasses_SetValueGenerator_s_t
 { ObjectArrayJc head;
   ClassOffset_idxMtblJc data[1];
 }interfaces_SetValueGenerator_s =
 { CONST_ObjectArrayJc(ClassOffset_idxMtblJc, 1, OBJTYPE_ClassOffset_idxMtblJc, null, null)
, { {&reflection_SetValueGenerator_ifc_s, OFFSET_Mtbl(Mtbl_SetValueGenerator, SetValueGenerator_ifc) }
  }
};

extern struct ClassJc_t const reflection_SetValueGenerator_s;
extern struct ClassJc_t const reflection_LogMessageFW_i;
extern struct ClassJc_t const reflection_OamVariables_s;
extern struct ClassJc_t const reflection_StringBuilderJc;
extern struct ClassJc_t const reflection_StringFormatterJc_s;
extern struct ClassJc_t const reflection_Target_SetValueGenerator_s;
const struct Reflection_Fields_SetValueGenerator_s_t
{ ObjectArrayJc head; FieldJc data[11];
} reflection_Fields_SetValueGenerator_s =
{ CONST_ObjectArrayJc(FieldJc, 11, OBJTYPE_FieldJc, null, &reflection_Fields_SetValueGenerator_s)
, {
     { "msg"
    , 0 //nrofArrayElements
    , &reflection_LogMessageFW_i
    , kEnhancedReference_Modifier_reflectJc /*@*/ |mObjectJc_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->msg) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
   , { "oamVariables"
    , 0 //nrofArrayElements
    , &reflection_OamVariables_s
    , kEnhancedReference_Modifier_reflectJc /*@*/ |mObjectJc_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->oamVariables) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
   , { "value"
    , 0 //nrofArrayElements
    , REFLECTION_int16
    , 2 << kBitPrimitiv_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->value) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
   , { "dvalue"
    , 0 //nrofArrayElements
    , REFLECTION_int16
    , 2 << kBitPrimitiv_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->dvalue) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
   , { "countStandStill"
    , 0 //nrofArrayElements
    , REFLECTION_int32
    , 4 << kBitPrimitiv_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->countStandStill) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
   , { "isWaitingForTarget"
    , 0 //nrofArrayElements
    , REFLECTION_bool
    , 4 << kBitPrimitiv_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->isWaitingForTarget) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
   , { "state"
    , 0 //nrofArrayElements
    , REFLECTION_int16
    , 2 << kBitPrimitiv_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->state) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
   , { "bufferFormatter"
    , 0 //nrofArrayElements
    , &reflection_StringBuilderJc
    , kEmbedded_Modifier_reflectJc |mObjectJc_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->bufferFormatter) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
   , { "sFormatter"
    , 0 //nrofArrayElements
    , &reflection_StringFormatterJc_s
    , kEmbedded_Modifier_reflectJc |mObjectJc_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->sFormatter) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
   , { "actTarget"
    , 0 //nrofArrayElements
    , &reflection_Target_SetValueGenerator_s
    , kEnhancedReference_Modifier_reflectJc /*@*/ |mObjectJc_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->actTarget) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
   , { "nextTarget"
    , 0 //nrofArrayElements
    , &reflection_Target_SetValueGenerator_s
    , kEnhancedReference_Modifier_reflectJc /*@*/ |mObjectJc_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->nextTarget) - (int32)(SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_SetValueGenerator_s
    }
} };
const ClassJc reflection_SetValueGenerator_s = 
{ CONST_ObjectJc(OBJTYPE_ClassJc + sizeof(ClassJc), &reflection_ObjectJc, &reflection_ClassJc) 
, "SetValueGenerator_s"
, (int16)((int32)(&((SetValueGenerator_s*)(0x1000))->base.object) - (int32)(SetValueGenerator_s*)0x1000)
, sizeof(SetValueGenerator_s)
, (FieldJcArray const*)&reflection_Fields_SetValueGenerator_s
, null //method
, (ClassOffset_idxMtblJcARRAY*)&superclasses_SetValueGenerator_s //superclass
, (ClassOffset_idxMtblJcARRAY*)&interfaces_SetValueGenerator_s //interfaces
, mObjectJc_Modifier_reflectJc
, &mtblSetValueGenerator.mtbl.head
};

/**A class contains the target values. */


const char sign_Mtbl_Target_SetValueGenerator[] = "Target_SetValueGenerator"; //to mark method tables of all implementations

typedef struct MtblDef_Target_SetValueGenerator_t { Mtbl_Target_SetValueGenerator mtbl; MtblHeadJc end; } MtblDef_Target_SetValueGenerator;
 extern MtblDef_Target_SetValueGenerator const mtblTarget_SetValueGenerator;

/*Constructor */
struct Target_SetValueGenerator_t* ctorO_Target_SetValueGenerator(ObjectJc* othis, ThCxt* _thCxt)
{ Target_SetValueGenerator_s* ythis = (Target_SetValueGenerator_s*)othis;  //upcasting to the real class.
  STACKTRC_TENTRY("ctorO_Target_SetValueGenerator");
  checkConsistence_ObjectJc(othis, sizeof(Target_SetValueGenerator_s), null, _thCxt);  
  setReflection_ObjectJc(othis, &reflection_Target_SetValueGenerator_s, sizeof(Target_SetValueGenerator_s));  
  //j2c: Initialize all class variables:
  {
    ythis->timeStandIdleOnTarget = 10;
  }
  { 
    
    
  }
  STACKTRC_LEAVE;
  return ythis;
}



void finalize_Target_SetValueGenerator_F(ObjectJc* othis, ThCxt* _thCxt)
{ Target_SetValueGenerator_s* ythis = (Target_SetValueGenerator_s*)othis;  //upcasting to the real class.
 STACKTRC_TENTRY("finalize_Target_SetValueGenerator_F");

  { //:System.out.println("finalize Target");
    
    
    sendMsg_z_LogMessageFW(REFJc(singleton_MainController->msg), kLifeCycle_ProcessMessageIdents, "finalize Target instance", _thCxt);
  }  CLEAR_REFJc(ythis->testGC);
  finalize_ObjectJc_F(&ythis->base.object, _thCxt); //J2C: finalizing the superclass.
  STACKTRC_LEAVE;
}




/**J2C: Reflections and Method-table *************************************************/
const MtblDef_Target_SetValueGenerator mtblTarget_SetValueGenerator = {
{ { sign_Mtbl_Target_SetValueGenerator//J2C: Head of methodtable.
  , (struct Size_Mtbl_t*)((0 +2) * sizeof(void*)) //size. NOTE: all elements are standard-pointer-types.
  }
, { { sign_Mtbl_ObjectJc//J2C: Head of methodtable.
    , (struct Size_Mtbl_t*)((5 +2) * sizeof(void*)) //size. NOTE: all elements are standard-pointer-types.
    }
  , clone_ObjectJc_F //clone
  , equals_ObjectJc_F //equals
  , finalize_Target_SetValueGenerator_F //finalize
  , hashCode_ObjectJc_F //hashCode
  , toString_ObjectJc_F //toString
  }
}, { signEnd_Mtbl_ObjectJc, null } }; //Mtbl


 extern struct ClassJc_t const reflection_ObjectJc;
 static struct superClasses_Target_SetValueGenerator_s_t
 { ObjectArrayJc head;
   ClassOffset_idxMtblJc data[1];
 }superclasses_Target_SetValueGenerator_s =
 { CONST_ObjectArrayJc(ClassOffset_idxMtblJc, 1, OBJTYPE_ClassOffset_idxMtblJc, null, null)
 , { {&reflection_ObjectJc, OFFSET_Mtbl(Mtbl_Target_SetValueGenerator, ObjectJc) }
   }
 };

extern struct ClassJc_t const reflection_Target_SetValueGenerator_s;
extern struct ClassJc_t const reflection_SetValueGenerator_s;
const struct Reflection_Fields_Target_SetValueGenerator_s_t
{ ObjectArrayJc head; FieldJc data[4];
} reflection_Fields_Target_SetValueGenerator_s =
{ CONST_ObjectArrayJc(FieldJc, 4, OBJTYPE_FieldJc, null, &reflection_Fields_Target_SetValueGenerator_s)
, {
     { "target"
    , 0 //nrofArrayElements
    , REFLECTION_int16
    , 2 << kBitPrimitiv_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((Target_SetValueGenerator_s*)(0x1000))->target) - (int32)(Target_SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_Target_SetValueGenerator_s
    }
   , { "velocity"
    , 0 //nrofArrayElements
    , REFLECTION_int16
    , 2 << kBitPrimitiv_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((Target_SetValueGenerator_s*)(0x1000))->velocity) - (int32)(Target_SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_Target_SetValueGenerator_s
    }
   , { "timeStandIdleOnTarget"
    , 0 //nrofArrayElements
    , REFLECTION_int16
    , 2 << kBitPrimitiv_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((Target_SetValueGenerator_s*)(0x1000))->timeStandIdleOnTarget) - (int32)(Target_SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_Target_SetValueGenerator_s
    }
   , { "testGC"
    , 0 //nrofArrayElements
    , &reflection_SetValueGenerator_s
    , kEnhancedReference_Modifier_reflectJc /*@*/ |mObjectJc_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((Target_SetValueGenerator_s*)(0x1000))->testGC) - (int32)(Target_SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_Target_SetValueGenerator_s
    }
} };
const ClassJc reflection_Target_SetValueGenerator_s = 
{ CONST_ObjectJc(OBJTYPE_ClassJc + sizeof(ClassJc), &reflection_ObjectJc, &reflection_ClassJc) 
, "Target_SetValueGenerator_s"
,  0 //position of ObjectJc
, sizeof(Target_SetValueGenerator_s)
, (FieldJcArray const*)&reflection_Fields_Target_SetValueGenerator_s
, null //method
, (ClassOffset_idxMtblJcARRAY*)&superclasses_Target_SetValueGenerator_s //superclass
, null //interfaces
, 0    //modifiers
, &mtblTarget_SetValueGenerator.mtbl.head
};


const char sign_Mtbl_OnlyTest_Target_SetValueGenerator[] = "OnlyTest_Target_SetValueGenerator"; //to mark method tables of all implementations

typedef struct MtblDef_OnlyTest_Target_SetValueGenerator_t { Mtbl_OnlyTest_Target_SetValueGenerator mtbl; MtblHeadJc end; } MtblDef_OnlyTest_Target_SetValueGenerator;
 extern MtblDef_OnlyTest_Target_SetValueGenerator const mtblOnlyTest_Target_SetValueGenerator;

/*Constructor *//**J2C: autogenerated as default constructor. */
struct OnlyTest_Target_SetValueGenerator_t* ctorO_OnlyTest_Target_SetValueGenerator(ObjectJc* othis, ThCxt* _thCxt)
{ OnlyTest_Target_SetValueGenerator_s* ythis = (OnlyTest_Target_SetValueGenerator_s*)othis;  //upcasting to the real class.
  STACKTRC_TENTRY("ctorO_OnlyTest_Target_SetValueGenerator");
  checkConsistence_ObjectJc(othis, sizeof(OnlyTest_Target_SetValueGenerator_s), null, _thCxt);  
  setReflection_ObjectJc(othis, &reflection_OnlyTest_Target_SetValueGenerator_s, sizeof(OnlyTest_Target_SetValueGenerator_s));  
  //j2c: Initialize all class variables:
  {
  }/*J2C:No body for constructor*/

  STACKTRC_LEAVE;
  return ythis;
}




/**J2C: Reflections and Method-table *************************************************/
const MtblDef_OnlyTest_Target_SetValueGenerator mtblOnlyTest_Target_SetValueGenerator = {
{ { sign_Mtbl_OnlyTest_Target_SetValueGenerator//J2C: Head of methodtable.
  , (struct Size_Mtbl_t*)((0 +2) * sizeof(void*)) //size. NOTE: all elements are standard-pointer-types.
  }
, { { sign_Mtbl_ObjectJc//J2C: Head of methodtable.
    , (struct Size_Mtbl_t*)((5 +2) * sizeof(void*)) //size. NOTE: all elements are standard-pointer-types.
    }
  , clone_ObjectJc_F //clone
  , equals_ObjectJc_F //equals
  , finalize_ObjectJc_F //finalize
  , hashCode_ObjectJc_F //hashCode
  , toString_ObjectJc_F //toString
  }
}, { signEnd_Mtbl_ObjectJc, null } }; //Mtbl


 extern struct ClassJc_t const reflection_ObjectJc;
 static struct superClasses_OnlyTest_Target_SetValueGenerator_s_t
 { ObjectArrayJc head;
   ClassOffset_idxMtblJc data[1];
 }superclasses_OnlyTest_Target_SetValueGenerator_s =
 { CONST_ObjectArrayJc(ClassOffset_idxMtblJc, 1, OBJTYPE_ClassOffset_idxMtblJc, null, null)
 , { {&reflection_ObjectJc, OFFSET_Mtbl(Mtbl_OnlyTest_Target_SetValueGenerator, ObjectJc) }
   }
 };

const ClassJc reflection_OnlyTest_Target_SetValueGenerator_s = 
{ CONST_ObjectJc(OBJTYPE_ClassJc + sizeof(ClassJc), &reflection_ObjectJc, &reflection_ClassJc) 
, "OnlyTest_Target_Se_nerator_s"
,  0 //position of ObjectJc
, sizeof(OnlyTest_Target_SetValueGenerator_s)
, null //attributes and associations
, null //method
, (ClassOffset_idxMtblJcARRAY*)&superclasses_OnlyTest_Target_SetValueGenerator_s //superclass
, null //interfaces
, 0    //modifiers
, &mtblOnlyTest_Target_SetValueGenerator.mtbl.head
};


const char sign_Mtbl_InnerTest_OnlyTest_Target_SetValueGenerator[] = "InnerTest_OnlyTest_Target_SetValueGenerator"; //to mark method tables of all implementations

typedef struct MtblDef_InnerTest_OnlyTest_Target_SetValueGenerator_t { Mtbl_InnerTest_OnlyTest_Target_SetValueGenerator mtbl; MtblHeadJc end; } MtblDef_InnerTest_OnlyTest_Target_SetValueGenerator;
 extern MtblDef_InnerTest_OnlyTest_Target_SetValueGenerator const mtblInnerTest_OnlyTest_Target_SetValueGenerator;

/*Constructor *//**J2C: autogenerated as default constructor. */
struct InnerTest_OnlyTest_Target_SetValueGenerator_t* ctorO_InnerTest_OnlyTest_Target_SetValueGenerator(ObjectJc* othis, ThCxt* _thCxt)
{ InnerTest_OnlyTest_Target_SetValueGenerator_s* ythis = (InnerTest_OnlyTest_Target_SetValueGenerator_s*)othis;  //upcasting to the real class.
  STACKTRC_TENTRY("ctorO_InnerTest_OnlyTest_Target_SetValueGenerator");
  checkConsistence_ObjectJc(othis, sizeof(InnerTest_OnlyTest_Target_SetValueGenerator_s), null, _thCxt);  
  setReflection_ObjectJc(othis, &reflection_InnerTest_OnlyTest_Target_SetValueGenerator_s, sizeof(InnerTest_OnlyTest_Target_SetValueGenerator_s));  
  //j2c: Initialize all class variables:
  {
  }/*J2C:No body for constructor*/

  STACKTRC_LEAVE;
  return ythis;
}




/**J2C: Reflections and Method-table *************************************************/
const MtblDef_InnerTest_OnlyTest_Target_SetValueGenerator mtblInnerTest_OnlyTest_Target_SetValueGenerator = {
{ { sign_Mtbl_InnerTest_OnlyTest_Target_SetValueGenerator//J2C: Head of methodtable.
  , (struct Size_Mtbl_t*)((0 +2) * sizeof(void*)) //size. NOTE: all elements are standard-pointer-types.
  }
, { { sign_Mtbl_ObjectJc//J2C: Head of methodtable.
    , (struct Size_Mtbl_t*)((5 +2) * sizeof(void*)) //size. NOTE: all elements are standard-pointer-types.
    }
  , clone_ObjectJc_F //clone
  , equals_ObjectJc_F //equals
  , finalize_ObjectJc_F //finalize
  , hashCode_ObjectJc_F //hashCode
  , toString_ObjectJc_F //toString
  }
}, { signEnd_Mtbl_ObjectJc, null } }; //Mtbl


 extern struct ClassJc_t const reflection_ObjectJc;
 static struct superClasses_InnerTest_OnlyTest_Target_SetValueGenerator_s_t
 { ObjectArrayJc head;
   ClassOffset_idxMtblJc data[1];
 }superclasses_InnerTest_OnlyTest_Target_SetValueGenerator_s =
 { CONST_ObjectArrayJc(ClassOffset_idxMtblJc, 1, OBJTYPE_ClassOffset_idxMtblJc, null, null)
 , { {&reflection_ObjectJc, OFFSET_Mtbl(Mtbl_InnerTest_OnlyTest_Target_SetValueGenerator, ObjectJc) }
   }
 };

extern struct ClassJc_t const reflection_InnerTest_OnlyTest_Target_SetValueGenerator_s;
const struct Reflection_Fields_InnerTest_OnlyTest_Target_SetValueGenerator_s_t
{ ObjectArrayJc head; FieldJc data[1];
} reflection_Fields_InnerTest_OnlyTest_Target_SetValueGenerator_s =
{ CONST_ObjectArrayJc(FieldJc, 1, OBJTYPE_FieldJc, null, &reflection_Fields_InnerTest_OnlyTest_Target_SetValueGenerator_s)
, {
     { "a"
    , 0 //nrofArrayElements
    , REFLECTION_int32
    , 4 << kBitPrimitiv_Modifier_reflectJc //bitModifiers
    , (int16)((int32)(&((InnerTest_OnlyTest_Target_SetValueGenerator_s*)(0x1000))->a) - (int32)(InnerTest_OnlyTest_Target_SetValueGenerator_s*)0x1000)
    , 0  //offsetToObjectifcBase
    , &reflection_InnerTest_OnlyTest_Target_SetValueGenerator_s
    }
} };
const ClassJc reflection_InnerTest_OnlyTest_Target_SetValueGenerator_s = 
{ CONST_ObjectJc(OBJTYPE_ClassJc + sizeof(ClassJc), &reflection_ObjectJc, &reflection_ClassJc) 
, "InnerTest_OnlyTest_nerator_s"
,  0 //position of ObjectJc
, sizeof(InnerTest_OnlyTest_Target_SetValueGenerator_s)
, (FieldJcArray const*)&reflection_Fields_InnerTest_OnlyTest_Target_SetValueGenerator_s
, null //method
, (ClassOffset_idxMtblJcARRAY*)&superclasses_InnerTest_OnlyTest_Target_SetValueGenerator_s //superclass
, null //interfaces
, 0    //modifiers
, &mtblInnerTest_OnlyTest_Target_SetValueGenerator.mtbl.head
};
