/****************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL is not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * @author Hartmut Schorrig: hartmut.schorrig@vishia.de, www.vishia.org
 * @version 0.93 2011-01-05  (year-month-day)
 *******************************************************************************/ 
package org.vishia.communication;


/**This class is the base class of the implementor of the InterProcessCommFactory.
 * The factory-implementor sets the instance. The user should know only this class,
 * not the implementation. Calling of   
 * 
*/
public abstract class InterProcessCommFactoryAccessor
{
	private static InterProcessCommFactory theSingleton;
  
	protected static void setSingleton(InterProcessCommFactory src){
		if(theSingleton !=null) throw new IllegalStateException("it is set already.");
		theSingleton = src;
	}
	
	public static InterProcessCommFactory getInstance()
	{ return theSingleton;  
	}
	

	
  
  
}

